﻿package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.utils.setInterval;

	public class Liner extends Sprite
	{
		public var balls:Array
		public function Liner()
		{
			balls = new Array();
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			setInterval(buildScreen,10);
			stage.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		private function fullhandler(e:FullScreenEvent):void
		{
			balls = new Array();
		}
		private function clickHandler(e:MouseEvent):void
		{
			var pt:Point = new Point(e.stageX,e.stageY);
			var obj:Object = {"posx":this.globalToLocal(pt).x,"posy":this.globalToLocal(pt).y,"angle":0,"rayon":(Math.random()*150 + 50),"centerY":this.globalToLocal(pt).y};
			balls.push(obj);
			balls.sortOn(["posx"],[Array.NUMERIC]);
		}
		
		private function buildScreen():void
		{
			this.graphics.clear();
			for(var i:Number = 0;i<balls.length;i++){
				graphics.beginFill(0xffffff,1);
				graphics.drawCircle(balls[i].posx,balls[i].posy,5);
				graphics.endFill();
				graphics.lineStyle(1,0xff0000,1);
				//draw the lines
				if(i>0){
					graphics.moveTo(balls[i-1].posx,balls[i-1].posy);
					graphics.lineTo(balls[i].posx,balls[i].posy);
				}
				graphics.lineStyle();
				//set the new position
				balls[i].posy = balls[i].centerY + Math.sin(balls[i].angle*Math.PI/180)*balls[i].rayon;
				balls[i].angle++;
			}
		}
	}
}